<script lang="ts" setup>
import AppContainer from "@/components/AppContainer.vue";
import { useQuery } from "vue-query";
import { groupsGetGroup } from "@/scripts/api-helper";
import GroupCard from "@/components/GroupCard.vue";
import { useRoute } from "vue-router";

const route = useRoute();

const group_uid = route.params.group_uid as string;

const {
  isLoading,
  isError,
  data: groupData,
  error,
} = useQuery(`get-group-${group_uid}`, async () => {
  const res = await groupsGetGroup({ uid: group_uid });
  if (!res.ok) {
    throw new Error("Failed to get group");
  }
  return res.data;
});

function copyToClipboard(text: string) {
  navigator.clipboard.writeText(text);
}
</script>

<template>
  <div>
    <div class="flex flex-row justify-center">
      <div v-if="isLoading">
        <v-progress-circular
          :size="74"
          :width="11"
          indeterminate
        ></v-progress-circular>
      </div>
      <div v-else-if="isError">
        <v-card :text="error.message" title="Error" width="400"></v-card>
      </div>
      <div v-else class="mt-2 flex flex-col justify-center">
        <v-card width="400">
          <v-card-text>
            <p class="text-subtitle-1 text-center">{{ groupData.name }}</p>
            <p class="text-2xl text-center mt-2">
              <span>{{ groupData.abv }}</span>
              <span v-if="groupData.unit_code"> @ </span>
              <a v-if="groupData.unit_code" class="hover:text-theme-accent">
                <router-link :to="`/units/${groupData.unit_code}`"
                  >{{ groupData.unit_code }}
                </router-link>
              </a>
              <span v-else> (Root)</span>
            </p>
          </v-card-text>
        </v-card>
        <div class="flex justify-center">
          <v-chip
            class="select-text mt-2"
            label
            size="small"
            @click="copyToClipboard(groupData.uid)"
          >
            UID: {{ groupData.uid }}
          </v-chip>
        </div>
      </div>
    </div>
  </div>
</template>
